#ifndef __BitsetHelper_hxx__
#define __BitsetHelper_hxx__
/*
  BitsetHelper.hxx
*/
#include <iostream>
#include <bitset>

template<unsigned long N>
std::bitset<N> subbits(const std::bitset<N>& x, 
		       unsigned int bit_high, unsigned int bit_low) {
  unsigned int nbits = bit_high - bit_low + 1;

  if (nbits <= 0 || nbits >= N || bit_high >= N) {
    return std::bitset<N>();
  } else {
    std::bitset<N> m;
    for (unsigned int i=bit_low; i<=bit_high; ++i) {
      m.set(i);
    }
    std::bitset<N> z = x & m;
    z >>= bit_low;
    return z;
  }
}

template<unsigned long N>
void to_bitset(std::bitset<N>& x, const char* data, unsigned int nbits) {
  x.reset();
  unsigned int i=0;
  unsigned int ic=0;
  unsigned int ib=0, ib2=0;

  while (i<nbits) {
    ib = i % 8;
    ib2 = 7 - ib;
    x.set(nbits-i-1, (data[ic]>>ib2) & 0x1);
    // std::cout << "ib, ic, ib2 = " << ib << ", " << ic << ", " << ib2 
    // 	      << std::endl;
    if (ib == 7) {
      ic ++;
    }
    i ++;
  }
}

template<unsigned long N>
void to_array(char* x, unsigned int& n, int nbits, const std::bitset<N>& data) {
  n = 0;
  unsigned int i=0, j=0;
  unsigned int ic=0;
  unsigned int ib=0, ib2=0;
  char bitdata=0;

  while (i < N) {
    j = N-i-1;
    ib = i % 8;
    ib2 = 7 - ib;
    if (ib == 0) {
      x[ic] = 0;
    }
    bitdata = 0;
    if (data[j]) bitdata = 1;
    x[ic] |= (bitdata << ib2);
    if (ib == 7) {
      ic ++;
    }
    i ++;
  }
  if ( (N%8) == 0) {
    n = N/8;
  } else {
    n = N/8 + 1;
  }
}


unsigned int subbits(unsigned int x, unsigned int bit2, unsigned int bit1);

#endif // __BitsetHelper_hxx__
