#ifndef __CommBufferUDP_hxx__
#define __CommBufferUDP_hxx__
/*
  CommBufferUDP.hxx
*/
#include "CommBase/CommBuffer.hxx"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

class CommBufferUDP : public CommBuffer {
public:
  CommBufferUDP();
  ~CommBufferUDP();

  const std::string socketType() const;
  void setIPAddressPort(const std::string& addr, int port);
  void updateDestinationFromSenderAddress();

protected:
  int recv_data(void* buf, unsigned int n);
  int send_data(const void* buf, unsigned int n);

protected:
  struct sockaddr_in mBindAddr; // Bind address
  struct sockaddr_in mSenderAddr; // Sender address
  struct sockaddr_in mDestAddr; // Destination address
};

#endif // __CommBufferUDP_hxx__
