/*
  CommBufferUDP.cxx
*/
#include <iostream>
#include <cstdio>
#include "CommBase/CommBufferUDP.hxx"
#include <cstring>

CommBufferUDP::CommBufferUDP() : CommBuffer() {
}

CommBufferUDP::~CommBufferUDP() {
}

const std::string CommBufferUDP::socketType() const {
  return "UDP";
}

void CommBufferUDP::setIPAddressPort(const std::string& addr, int port) {
  CommBuffer::setIPAddressPort(addr, port);

  std::memset(&mBindAddr, 0, sizeof(struct sockaddr_in) );
  mBindAddr.sin_family = AF_INET;
  inet_pton(AF_INET, mIPAddress.c_str(), &mBindAddr.sin_addr);
  mBindAddr.sin_port = htons(mPort);

  std::memset(&mDestAddr, 0, sizeof(struct sockaddr_in) );
  mDestAddr.sin_family = AF_INET;
  inet_pton(AF_INET, mIPAddress.c_str(), &mDestAddr.sin_addr);
  mDestAddr.sin_port = htons(mPort);
}

void CommBufferUDP::updateDestinationFromSenderAddress() {
  char senderstr[100];
  inet_ntop(AF_INET, &mSenderAddr.sin_addr, senderstr, sizeof(senderstr));
  //inet_pton(AF_INET, senderstr, &mBindAddr.sin_addr);
  int port = ntohs(mSenderAddr.sin_port);
  std::printf("Update destination address to host=%s, port=%d\n", 
	      senderstr, port);

  mDestAddr.sin_family = AF_INET;
  mDestAddr.sin_addr = mSenderAddr.sin_addr;
  mDestAddr.sin_port = mSenderAddr.sin_port;
}

int CommBufferUDP::recv_data(void* buf, unsigned int n) {
  socklen_t addrlen = sizeof(mSenderAddr);
  // std::cout << "recvfrom ... n=" << n << " socket=" << mSocket << std::endl;
  int a = ::recvfrom(mSocket, buf, n, 0, 
		     (struct sockaddr*) &mSenderAddr, &addrlen);
  // std::cout << "a=" << a << std::endl;
  return a;
}

int CommBufferUDP::send_data(const void* buf, unsigned int n) {
  // std::cout << "SocketUDP in send data size=" << n << std::endl;
  // const char* cbuf = reinterpret_cast<const char*>(buf);
  // std::cout << "Socket in send_data: " << mSocket << std::endl;
  // std::cout << " write " << n << " bytes" << std::endl;
  // for (unsigned int i=0; i<n; ++i) {
  //   std::cout << "  cbuf[" << i << "] " << cbuf[i] << " " 
  // 	      << static_cast<const int>(cbuf[i]) << std::endl;
  // }
  // std::cout << " data=" << cbuf << std::endl;
  // std::cout << " go" << std::endl;
  return ::sendto(mSocket, buf, n, 0, 
		  (struct sockaddr*) &mDestAddr, sizeof(struct sockaddr_in) );
}

