#ifndef __Operation_hxx__
#define __Operation_hxx__
/*
  Operation.hxx

  last updated : 2017.02.13
*/
#include "PixelDAQ/System.hxx"
#include "PixelDAQ/DaqController.hxx"

class OperationParameter {
public:
  std::string IP_ADDRESS;
  int TCP_PORT;
  int UDP_PORT;
  int FIRMWARE_TYPE;
};

class Operation {
public:
  Operation();
  ~Operation();
  
  void setDaqController(DaqController* daq);
  
  int initialize();
  int readSystemConfig(const std::string& filename);
  int readOperationPar(const std::string& filename);
  void printOperationPar(std::ostream& out=std::cout);
  int configure();
  int finalize();
  int enableDout(int chipID);
  

protected:
  System mSystem;
  DaqController* mDaq;
  OperationParameter mOpe_p;

private:
  std::bitset<8> mStatus;
  
};

void setParameters(std::string& word1, std::string& word2,
		   int& p, const std::string& name);

#endif // __Operation_hxx__
