/*
  FEI4B.cxx
*/
#include "PixelDAQ/FEI4B.hxx"

FEI4B::FEI4B(int id, bool active) : mID(id), mActive(active) {
}

FEI4B::FEI4B() : mID(0x0), mActive(false) {
}
  
FEI4B::~FEI4B() {
}

void FEI4B::setRegister(int regAdd, unsigned int data) {
  if (regAdd>=0 && regAdd<=35) {
    mReg[regAdd] = data;
  }
  return;
}

unsigned int FEI4B::getRegister(int regAdd) const {
  if (regAdd>=0 && regAdd<=35) {
    return mReg[regAdd];
  }
  return 0;
}

void FEI4B::resetRegister() {
  for(int i=0; i<=35; ++i) {
    mReg[i] = 0x00;
  }
}

