/*
  Module.cxx
*/

#include "PixelDAQ/Module.hxx"
#include "PixelDAQ/FEI4B.hxx"

Module::Module() : mID(0x0), mActive(false) {
}

Module::Module(int id, bool active) : mID(id), mActive(active) {
}

Module::~Module() {
  removeChips();
}

void Module::createChips(int* chipID, int n) {
  removeChips();
  for (int i=0; i<n; ++i) {
    mChip_m[i] = new FEI4B(chipID[i], true);
  }
  mNChips = n;
  return;
}

void Module::setRegister(int chipID, int regAdd, unsigned int data) {
  mChip_m.at(chipID)->setRegister(regAdd, data);
  return;
}

unsigned int Module::getRegister(int chipID, int regAdd) const {
  unsigned int value = mChip_m.at(chipID)->getRegister(regAdd);
  return value;
}

void Module::removeChips() {
  mChip_m.clear(); //delete
  return;
}




