/*
  daq_test.cxx

  last updated : 2017.02.14
*/
#include <cstdio>
#include <iostream>
#include <fstream>
#include "CommBase/GlobalConfig.hxx"
#include "PixelDAQ/DaqControllerN.hxx"
#include "PixelDAQ/Operation.hxx"

int main(int argc, char* argv[]) {
  std::cout<<std::endl;
  std::cout<<">> ---- START DAQ TEST ----- <<"<<std::endl;
  std::cout<<std::endl;

  GlobalConfig* gconfig = GlobalConfig::get();
  // gconfig->setOutputLevel(GlobalConfig::kDEBUG3);
  gconfig->setOutputLevel(GlobalConfig::kVERBOSE);

  int ret=0;

  DaqControllerN daq;
  Operation ope;
  ope.setDaqController(&daq);
  ret = ope.initialize();
  ret = ope.readSystemConfig("config/SystemConfig.txt");
  ret = ope.readOperationPar("config/OperationPara.txt");
  ret = ope.configure();
  if (ret) return -1;
  
  // unsigned int val = daq.readStatus(0x1);
  // std::cout<<"val = "<<std::endl;

  ope.finalize();

  return 0;
}

