/*
  startController.cxx

  last updated : 2017.02.13
*/
#include <cstdio>
#include <iostream>
#include <fstream>
#include "CommBase/GlobalConfig.hxx"
#include "CommBase/CommunicationMgr.hxx"
#include "PixelDAQ/System.hxx"
#include "PixelDAQ/DaqControllerH.hxx"
#include "PixelDAQ/Operation.hxx"

int main(int argc, char* argv[]) {
  GlobalConfig* gconfig = GlobalConfig::get();
  // gconfig->setOutputLevel(GlobalConfig::kDEBUG3);
  gconfig->setOutputLevel(GlobalConfig::kVERBOSE);
  
  /* build system in software */
  System sys;
  int mid[1] = { 0x1 };
  int chipid[1] = { 0x0 };
  sys.createModules(mid, 1);
  sys.createChips(mid[0], chipid, 1);
  sys.print();

  /* setup DaqController */
  DaqControllerH daq;
  if (daq.initialize())  return -1;
  CommunicationMgr& cm_tcp = daq.getCommMgrTCP();
  CommunicationMgr& cm_udp = daq.getCommMgrUDP();
  cm_tcp.setIPAddressPort("192.168.10.16", 24);   // for SiTCP TCP port
  cm_udp.setIPAddressPort("192.168.10.16", 4660); // for SiTCP UDP port
  // cm_tcp.setIPAddressPort("localhost", 50001);
  if (daq.configure())  return -1;

  daq.enableDout(chipid[0]);
  //daq.readRegister(chipid[0], 0x20);
  //daq.setRunMode(chipid[0]);
  //sleep(5);
  daq.writeRegister(chipid[0], 29, 0x0007);
  //daq.globalReset(chipid[0]);
  daq.readRegister(chipid[0], 0x20);
  
  // unsigned int val = daq.readStatus(0x1);
  
  return 0;
}

