/*
  startServer.cxx
*/
#include <string>
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include "CommBase/CommunicationMgr.hxx"
#include "CommBase/CommandSet.hxx"
#include "CommBase/A6Message.hxx"

void test1();
void test2();

int main(int argc, char* argv[]) {
  // test1();
  test2();
  return 0;
}

void test2() {
  A6Message msg;
  int status;
  char data[1000];
  CommunicationMgr cm("TCP", 10000);
  cm.setIPAddressPort("localhost", 50001);
  cm.bind();
  while (true) {
    std::cout << "Listening for connection request" << std::endl;
    status = cm.listen();
    std::cout << "Waiting to accept a connection request" << std::endl;
    CommunicationMgr* cm1 = cm.accept();
    std::cout << "Connect request accepted" << std::endl;
    
    int nmax=2;
    int n=0;
    while (n < nmax) {
      //std::cout << "Waiting for a message from the client" << std::endl;
      std::cout<<"n = "<< ++n <<std::endl;
      cm1->read(msg);
      std::cout << "Message received: " << msg.payloadSize() << " bytes" 
		<< std::endl;
      msg.dump(std::cout);
      // int plsize = 0x1;
      // char pl[1] = { 0x1f };
      // msg.clear();
      // msg.setType(0xa6);
      // msg.setCommandID(0x1);
      // msg.setPayload(pl, plsize);
      // std::cout<<"send command"<<std::endl;
      // cm1->write(msg);
    }
    cm1->close();
    break;
  }
  cm.close();

  return;
}

void test1() {
  CommunicationMgr cm("UDP", 10000);
  cm.setIPAddressPort("localhost", 50001);
  cm.bind();

  char data[100];
  int nmax=35;
  int n=0;

  while (n<nmax) {
    CommandSet cmd;
    std::cout<<"Waiting for a message from the client"<<std::endl;
    cm.read(cmd);
    if (n==0) {
      cm.buffer()->updateDestinationFromSenderAddress();
    }
    std::cout<<"Message received: "<< cmd.packetSize() <<" bytes"<<std::endl;;
    cmd.dump(std::cout);
    // std::memcpy(data, cmd.payload(), cmd.payloadSize());
    // int plsize = cmd.payloadSize();

    int rw     = 0xc8;
    int add    = 0x1;
    int plsize = 0x1;
    char pl[1] = { 0x1f };
    cmd.clear();
    cmd.setType(0xff);
    cmd.setRW(rw);
    cmd.setCommandID(add);
    cmd.setAddress(add);
    cmd.setPayload(pl, plsize);
    std::cout<<"send command"<<std::endl;
    cmd.dump(std::cout);
    cm.write(cmd);
    n++;
  }
  cm.close();
 
  return;
}

