#ifndef __A6Message_hxx__
#define __A6Message_hxx__
/*
  A6Message.hxx

  last updated : 2017.02.09
*/
#include <iostream>

class A6Message {
public:
  A6Message(int type);
  A6Message();
  ~A6Message();

  /*----------------------------------------------*/
  /* << A6Message format >>                       */
  /*   Message Type : 1 byte (0xA6 = 10100110)    */
  /*   Command ID   : 1 byte                      */
  /*   Payload Size : 1 byte                      */
  /*   Payload      : 4 bytes                     */
  /*----------------------------------------------*/
  
  void setType(int i)        { mData[0] = i & 0xff; }
  void setCommandID(int i)   { mData[1] = i & 0xff; }
  void setPayloadSize(int i) { mData[2] = i & 0xff; }
  void setPayload(const char* payload_c, int plsize);
  void appendPayload(const char* s, int nbytes);

  int type()             const;
  int commandID()        const;
  int payloadSize()      const;
  const char* payload()  const;

  int headerSize() const { return 3; }
  int packetSize() const;
  char* data() { return mData; }

  void clear();
  void clearPayload();
  void dump(std::ostream& out);

protected:
  char mData[1024];

private:

};

#endif // __A6Message_hxx__
