#ifndef __CommBuffer_hxx__
#define __CommBuffer_hxx__
/*
  CommBuffer.hxx
*/
#include <string>

class CommBuffer {
public:
  CommBuffer();
  virtual ~CommBuffer();

  int allocate_data(unsigned int nbytes);
  int free_data();
  bool empty() const;

  unsigned int bufferSize() const { return mBufferSize; }
  unsigned int sizeForRead() const;
  unsigned int sizeForWrite() const;
  unsigned int sizeForReadContinuous() const;
  unsigned int sizeForWriteContinuous() const;

  int read(void* buf, unsigned int n);
  int write(const void* buf, unsigned int n);

  virtual const std::string socketType() const;
  virtual void setIPAddressPort(const std::string& addr, int port);
  virtual void updateDestinationFromSenderAddress();
  void setSocket(int s) { mSocket = s; }

  void print() const;

protected:
  virtual int recv_data(void* buf, unsigned int n);
  virtual int send_data(const void* buf, unsigned int n);

protected:
  std::string mIPAddress;
  int mPort;
  int mSocket;

  int mBufferSize;
  char* mData;
  int mWritePointer;
  int mReadPointer;
};

#endif // __CommBuffer_hxx__
