#ifndef __CommandSet_hxx__
#define __CommandSet_hxx__
/*
  CommandSet.hxx

  last updated : 2017.02.09
*/
#include <string>
#include <ostream>

/*------------------------------------------------*/
/* CommandSet class : for SiTCP UDP communication */
/*------------------------------------------------*/

class CommandSet {
public:
  CommandSet(int type);
  CommandSet();
  ~CommandSet();
  
  void setType(int i)        { mData[0] = (i & 0xff); }
  void setRW(int i)          { mData[1] = (i & 0xff); }
  void setCommandID(int i)   { mData[2] = (i & 0xff); }
  void setPayloadSize(int i) { mData[3] = (i & 0xff); }
  void setAddress(unsigned int i);
  void setPayload(const char* payload_c, int plsize);
  void appendPayload(const char* s, int nbytes);

  int type()         const;
  int rw()           const;
  int commandID()    const;
  int payloadSize()  const;
  unsigned int address() const;
  const char* payload()  const;

  int headerSize() const { return 8; }
  int packetSize() const;
  char* data() { return mData; }

  void clear();
  void clearPayload();
  void dump(std::ostream& out);

protected:
  int mChipMask;
  char mData[1024];
  
private:
};

#endif


