#ifndef __DaqController_hxx__
#define __DaqController_hxx__
/*
  DaqController.hxx 
  
  last updated : 2017.02.13
*/
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <sstream>
#include <string>
#include <bitset>
#include "CommBase/CommunicationMgr.hxx"

class System;

class DaqController {
public:
  DaqController();
  ~DaqController();

  CommunicationMgr& getCommMgrTCP() { return mCM_tcp; }
  CommunicationMgr& getCommMgrUDP() { return mCM_udp; }
  void setSystem(System* sys) { mSys = sys; }
  virtual int initialize();
  virtual int configure();
  virtual int finalize();

  /* List of commands for FE-I4 chips */;
  virtual int BCReset();
  virtual int ECReset();
  virtual int calPulse();
  virtual unsigned int readRegister(int chipID, int gr_address);
  virtual int writeRegister(int chipID, int gr_address, unsigned short data);
  // virtual int writeFrontEnd(int chipID, char* senddata, char* recvdata,
  // 		    bool output=false);
  virtual int globalReset(int chipID);
  virtual int globalPulse(int chipID, int width);
  virtual int setRunMode(int chipID);
  virtual int setConfMode(int chipID);

protected:
  CommunicationMgr mCM_tcp;
  CommunicationMgr mCM_udp;
  std::bitset<8> mStatus;
  System* mSys;

private:
};

#endif  // __DaqController_hxx__


