#ifndef __DaqControllerN_hxx__
#define __DaqControllerN_hxx__
/*
  DaqControllerN.hxx 
  
  last updated : 2017.02.13
*/
#include "PixelDAQ/DaqController.hxx"

class DaqControllerN : public DaqController {
public:
  enum CommandID { kChipCommand  = 0x01,
		   kInRegCommand = 0x10  };
  
public:
  DaqControllerN();
  ~DaqControllerN();

  int initialize();
  int configure();
  int finalize();

  /* List of commands for FE-I4 chips */;
  int BCReset();
  int ECReset();
  int calPulse(); // to be updated...
  unsigned int readRegister(int chipID, int gr_address);
  int writeRegister(int chipID, int gr_address, unsigned short data);
  // int writeFrontEnd(int chipID, char* senddata, char* recvdata,
  // 		    bool output=false);
  int globalReset(int chipID);
  int globalPulse(int chipID, int width);
  int setRunMode(int chipID);
  int setConfMode(int chipID);

public:
  int sendCommand(int cmdid, int plsize, char* payload);
  int sendFastCommand(int type);
  int sendSlowCommand(int type, int chipid, int field5, unsigned short field6);

  int enableDout(int chipID);

  /* List of command for firmware */
  unsigned int readStatus(int add);
  
private:
};

#endif  // __DaqControllerN_hxx__


