#ifndef __Decoder_hxx__
#define __Decoder_hxx__
/*
  Decoder.hxx

  last updated : 2017.02.02
*/
#include <iostream>
#include <stdlib.h>

class Decoder {
public:
  Decoder();
  ~Decoder();
  
  int decode(const char* c_data);
  void clear();
  void info(std::ostream& out);
  
  unsigned short chipID()     const { return mChipID;  }
  unsigned short triggerID()  const { return mTrigID;  }
  unsigned short BCID()       const { return mBCID;    }
  unsigned short column()     const { return mColumn;  }
  unsigned short row()        const { return mRow;     }
  unsigned short ToT_top()    const { return mToT_top; }
  unsigned short ToT_bot()    const { return mToT_bot; }
  unsigned short address()    const { return mAddress; }
  unsigned short value()      const { return mRegVal;  }
  unsigned short SR()         const { return mSR;      }
  unsigned short SR_pl()      const { return mSR_pl;   }

private:
  unsigned short mChipID;
  unsigned short mField1;
  unsigned short mField2;
  unsigned short mTrigID;
  unsigned short mBCID;
  unsigned short mColumn;
  unsigned short mRow;
  unsigned short mToT_top;
  unsigned short mToT_bot;
  unsigned short mRegType;
  unsigned short mAddress;
  unsigned short mRegVal;
  unsigned short mSR;
  unsigned short mSR_pl;

protected:
};


#endif  //__Decoder_hxx__
