/*
  Module.hxx
*/
#include <map>
class FEI4B;

class Module {
public:
  Module(int id, bool active=true);
  Module();
  ~Module();
  
  void setID(int i)      { mID = i; }
  void setActive(bool b) { mActive = b; }
  void createChips(int* chipID, int n);

  int id()            const { return mID;     }
  bool acvtive()      const { return mActive; }
  int numberOfChips() const { return mNChips; }

  void setRegister(int chipID, int regAdd, unsigned int data);
  unsigned int getRegister(int chipID, int regAdd) const;

  void removeChips();

protected:
  int mID;
  bool mActive;
  int mNChips;
  std::map<int, FEI4B*> mChip_m;
};


