#ifndef __System_hxx__
#define __System_hxx__
/*
  System.hxx
*/
#include <cstdlib>
#include <iostream>
#include <vector>
#include <map>

class Module;

class System {
public:
  System();
  ~System();
  
  void createModules(int* moduleID, int n);
  void createChips(int moduleID, int* chipID, int n);
  void print(std::ostream& out=std::cout);
  
  int numberOfModules();
  int numberOfChips(int moduleID);
  int numberOfChips();
  
  void setRegister(int moduleID, int chipID, int regAdd, unsigned int data);
  unsigned int getRegister(int moduleID, int chipID, int regAdd) const;

protected:
  std::map<int, Module*> mModule_m;
  unsigned int mInReg[50]; // 50 ?????
  
private:
  
};

#endif // __System_hxx__
