/*
  chat_client.cxx
*/
#include "CommBase/GlobalConfig.hxx"
#include "CommBase/CommunicationMgr.hxx"
#include "CommBase/A6Message.hxx"
#include <string>
#include <iostream>
#include <cstdlib>

int main(int argc, char* argv[]) {
  std::string hostaddr;
  int port;

  GlobalConfig::get()->setOutputLevel(GlobalConfig::kVERBOSE);
  if (argc <= 1) {
    std::cout << "Usage: " << argv[0] << " <hostIP> <port>" << std::endl;
    exit(-1);
  }
  hostaddr = argv[1];
  port = std::atoi(argv[2]);
  std::cout<<"hostadd = "<< hostaddr <<std::endl;
  CommunicationMgr cm("TCP", 10000);
  cm.setIPAddressPort(hostaddr, port);
  int status;
  A6Message msg;

  char data[2] = {0xf1, 0x03};

  status = cm.connect();
  
  for (int j=0; j<10; j++) {
    for (int i=0; i<5; ++i) {
      msg.setType(0xa6);
      msg.setCommandID(0x1);
      usleep(1);
      msg.setPayload(data, 2);
      std::cout << "Write message: " << std::endl;
      msg.dump(std::cout);
      cm.write(msg);
      std::cout << "Read message" << std::endl;
      cm.read(msg);
      std::cout << "Message from server: " << msg.payload() << std::endl;
    }
  }

  cm.close();
  
  return 0;
}
