/*
  chat_server.cxx
*/
#include "CommBase/CommunicationMgr.hxx"
#include "CommBase/GlobalConfig.hxx"
#include <string>
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include "CommBase/A6Message.hxx"

int main(int argc, char* argv[]) {
  A6Message msg;

  //GlobalConfig::get()->setOutputLevel(GlobalConfig::kVERBOSE);
  
  int status;
  char data[1000]="REPLY:";
  std::string hostaddr;
  int port;

  if (argc <= 1) {
    std::cout << "Usage: " << argv[0] << " <hostIP> <port>" << std::endl;
    exit(-1);
  }
  hostaddr = argv[1];
  port = std::atoi(argv[2]);

  CommunicationMgr cm("TCP", 10000);
  cm.setIPAddressPort(hostaddr, port);
  cm.bind();
  while (true) {
    std::cout << "Listening for connection request" << std::endl;
    status = cm.listen();
    std::cout << "Waiting to accept a connection request" << std::endl;
    CommunicationMgr* cm1 = cm.accept();
    std::cout << "Connect request accepted" << std::endl;
    
    int nmax=50;
    int n=0;
    while (n < nmax) {
      std::memset(data, 0, sizeof(data));
      // std::cout << "Waiting for a message from the client" << std::endl;
      std::cout<<"n = "<< ++n <<std::endl;
      cm1->read(msg);
      std::cout << "Message received: " << msg.payloadSize() << " bytes" 
		<< std::endl;
      std::memcpy(data+6, msg.payload(), msg.payloadSize());
      int plsize = msg.payloadSize() + 6;
      msg.setType(0xa6);
      msg.setCommandID(0x1);
      msg.setPayload(data, plsize);
      cm1->write(msg);
    }
    cm1->close();
    break;
  }
  cm.close();
  
  return 0;
}
